//+------------------------------------------------------------------+
//|                                              GenericTemplate.mq4 |
//|                               Copyright 2022, chart.view Courses |
//|                              http://www.instagram.com/chart.view |
//+------------------------------------------------------------------+
#property copyright  "Copyright 2022, Chart.view Courses"
#property link       "https://t.me/MQL4club/"
#property version    "1.00"
#property strict
#property description "visit us on : "
#property description "https://Instagram.com/chart.view"
#property description "https://t.me/MQL4club"
#property description "https://youtube.com/MQL4club"
#include <stderror.mqh>
#include <stdlib.mqh>

extern double StopLoss=0.0;
extern double TakeProfit=20;
input double   LotSize=0.1;//The Lotsize you would like to use.
input int Macd_Filter = 20; //Macd_Filter(pips)
input int Trade_Space = 5; //Trade_Space(pips)
extern int MagicSeed=1000;//Number from which to compute MagicNumber
extern int TotalAttempts = 5; // Total attempts to open order
int MagicNumber;
double pips;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
//---Generate a magic number based on our MagicSeed
   MagicNumber = MagicNumberGenerator();

// Determine what a pip is.
   CalculatePips();

//---
#include<init_checks.mqh>
//---
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
//---

}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
//---
   static datetime candletime = 0;
   if(candletime != Time[0])
   {
      CheckForSignal();
      candletime = Time[0];
   }
}

//+------------------------------------------------------------------+
//|       TRIGGER FUNCTION                                           |
//+------------------------------------------------------------------+
void CheckForSignal()
{
   double macd_1 = iMACD(_Symbol,PERIOD_CURRENT,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
   double macd_2 = iMACD(_Symbol,PERIOD_CURRENT,12,26,9,PRICE_CLOSE,MODE_MAIN,2);
   double macd_3 = iMACD(_Symbol,PERIOD_CURRENT,12,26,9,PRICE_CLOSE,MODE_MAIN,3);
   
   //--- Sell Positions Condition
   if(macd_2 > macd_3 && macd_1 < macd_2 && macd_1 > (Macd_Filter * pips))
   {
      if(TotalSellOrders() > 0)
      {
         if(Bid - HighestSellPrice() >= Trade_Space*pips)
            EnterTrade(OP_SELL);
      }
      else
         EnterTrade(OP_SELL);
   }
   
   //--- Buy Positions Condition
   if(macd_2 < macd_3 && macd_1 > macd_2 && macd_1 < (-Macd_Filter * pips))
   {
      if(TotalBuyOrders() > 0)
      {
         if(LowestBuyPrice() - Ask >= Trade_Space * pips)
            EnterTrade(OP_BUY);
      }
      else
         EnterTrade(OP_BUY);
   }
}
//+------------------------------------------------------------------+
//|     TRADE PLACING FUNCTION                                       |
//+------------------------------------------------------------------+
void EnterTrade(int type)
{

   int err=0;
   double price=Bid,
          sl=0,
          tp=0,
          lotsize = LotSize;
   color order_color = clrRed;
   lotsize = (TotalSellOrders() + 1) * LotSize;
   
   if(type == OP_BUY)
   {
      price =Ask;
      order_color = clrBlue;
      lotsize = (TotalBuyOrders() + 1) * LotSize;

   }
   //----
   int ticket = -1;
   
   //--- try to open order
   for(int i=0;i<TotalAttempts;i++)
   {
      ticket = OrderSend(Symbol(),type,lotsize,price,30,0,0,"Ea Template",MagicNumber,0,order_color);
      
      if(ticket > -1) break;
      else
      {
         Sleep(500);
         RefreshRates();
         
         if(type == OP_BUY) price = Ask;
         else               price = Bid;      
      }      
   }
   
   if(ticket>0)
   {
      if(OrderSelect(ticket,SELECT_BY_TICKET))
      {
         if(OrderType()==OP_SELL)
         {
            sl = OrderOpenPrice()+(StopLoss*pips);
            if(StopLoss==0)sl=0;
            tp = BreakEvenOfSellOrders() -(TakeProfit*pips);
         }
         else if(OrderType()==OP_BUY)
         {
            sl = OrderOpenPrice()-(StopLoss*pips);
            if(StopLoss==0)sl=0;
            tp = BreakEvenOfBuyOrders()+(TakeProfit*pips);
         }
         //--- Modify This Order
         if(!OrderModify(ticket,price,sl,tp,0,clrNONE))
         {
            err = GetLastError();
            Print("Encountered an error during modification!"+(string)err+" "+ErrorDescription(err)  );
         }
         
         //--- Modify The Other Orders
         int total = type == OP_BUY? TotalBuyOrders() : TotalSellOrders();
         if(total >1)
         {
            for(int i=0;i<OrdersTotal()-1 ;i++)
            {
               if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
                  if(OrderMagicNumber() == MagicNumber)
                     if(OrderType() == type)
                        if(!OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),tp,0,clrNONE))
                        {
                           err = GetLastError();
                           Print("Encountered an error during modification!"+(string)err+" "+ErrorDescription(err)  );
                        }
            }
         }
      }
      else
      {
         //in case it fails to select the order for some reason
         Print("Failed to Select Order ",ticket);
         err = GetLastError();
         Print("Encountered an error while seleting order "+(string)ticket+" error number "+(string)err+" "+ErrorDescription(err)  );
      }
   }
   else
   {
      //in case it fails to place the order and send us back a ticket number.
      err = GetLastError();
      Print("Encountered an error during order placement!"+(string)err+" "+ErrorDescription(err)  );
      if(err==ERR_TRADE_NOT_ALLOWED)MessageBox("You can not place a trade because \"Allow Live Trading\" is not checked in your options. Please check the \"Allow Live Trading\" Box!","Check Your Settings!");
   }
}
//+------------------------------------------------------------------+
//Total of Sell orders place by this expert.
//+------------------------------------------------------------------+
int TotalSellOrders()
{
   int total=0;
   for(int i=OrdersTotal()-1; i >= 0; i--)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if(OrderMagicNumber()== MagicNumber)
            if(OrderType() == OP_SELL)
               total++;
      }
      else Print("Failed to select order",GetLastError());
   }
   return (total);
}
//+------------------------------------------------------------------+
//Total of Buy orders place by this expert.
//+------------------------------------------------------------------+
int TotalBuyOrders()
{
   int total=0;
   for(int i=OrdersTotal()-1; i >= 0; i--)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if(OrderMagicNumber()== MagicNumber)
            if(OrderType() == OP_BUY)
               total++;
      }
      else Print("Failed to select order",GetLastError());
   }
   return (total);
}
//+------------------------------------------------------------------+
//|   Calculate Pips                                                 |
//+------------------------------------------------------------------+
void CalculatePips()
{
   pips=_Point;      //.00001 or .0001. .001 .01.

   if(_Digits == 5 || _Digits == 3)
   {
      pips *= 10;
   }
   else if((StringSubstr(Symbol(),0,6)=="XAUUSD" ||
            StringSubstr(Symbol(),0,4)=="Gold"   ||
            StringSubstr(Symbol(),0,4)=="GOLD") && Digits==2)
   {
      pips *= 10;
   }
   else if((StringSubstr(Symbol(),0,6)=="XAGUSD" ||
            StringSubstr(Symbol(),0,6)=="Silver" ||
            StringSubstr(Symbol(),0,6)=="SILVER") && Digits==3)
   {
      pips *= 10;
   }
}
//+------------------------------------------------------------------+
//|Generate a Magic Number                                           |
//+------------------------------------------------------------------+
int MagicNumberGenerator()
{
   string mySymbol = StringSubstr(_Symbol,0,6);
   int pairNumber=0;
   int GeneratedNumber =0;
   if (mySymbol == "AUDCAD")   pairNumber=1;
   else if (mySymbol == "AUDCHF")   pairNumber=2;
   else if (mySymbol == "AUDJPY")   pairNumber=3;
   else if (mySymbol == "AUDNZD")   pairNumber=4;
   else if (mySymbol == "AUDUSD")   pairNumber=5;
   else if (mySymbol == "CADCHF")   pairNumber=6;
   else if (mySymbol == "CADJPY")   pairNumber=7;
   else if (mySymbol == "CHFJPY")   pairNumber=8;
   else if (mySymbol == "EURAUD")   pairNumber=9;
   else if (mySymbol == "EURCAD")   pairNumber=10;
   else if (mySymbol == "EURCHF")   pairNumber=11;
   else if (mySymbol == "EURGBP")   pairNumber=12;
   else if (mySymbol == "EURJPY")   pairNumber=13;
   else if (mySymbol == "EURNZD")   pairNumber=14;
   else if (mySymbol == "EURUSD")   pairNumber=15;
   else if (mySymbol == "GBPAUD")   pairNumber=16;
   else if (mySymbol == "GBPCAD")   pairNumber=17;
   else if (mySymbol == "GBPCHF")   pairNumber=18;
   else if (mySymbol == "GBPJPY")   pairNumber=19;
   else if (mySymbol == "GBPNZD")   pairNumber=20;
   else if (mySymbol == "GBPUSD")   pairNumber=21;
   else if (mySymbol == "NZDCAD")   pairNumber=22;
   else if (mySymbol == "NZDJPY")   pairNumber=23;
   else if (mySymbol == "NZDCHF")   pairNumber=24;
   else if (mySymbol == "NZDUSD")   pairNumber=25;
   else if (mySymbol == "USDCAD")   pairNumber=26;
   else if (mySymbol == "USDCHF")   pairNumber=27;
   else if (mySymbol == "USDJPY")   pairNumber=28;
   else if((StringSubstr(Symbol(),0,6)=="XAUUSD" ||
            StringSubstr(Symbol(),0,4)=="Gold"   ||
            StringSubstr(Symbol(),0,4)=="GOLD") && Digits==2)
   {
      pairNumber=29;
   }
   else if((StringSubstr(Symbol(),0,6)=="XAGUSD" ||
            StringSubstr(Symbol(),0,6)=="Silver" ||
            StringSubstr(Symbol(),0,6)=="SILVER") && Digits==3)
   {
      pairNumber=30;
   }
   GeneratedNumber = MagicSeed + (pairNumber*1000) + _Period;
   return(GeneratedNumber);
}

//+------------------------------------------------------------------+
//|  Highest Sell Positions Price                                    |
//+------------------------------------------------------------------+
double HighestSellPrice()
{
   double highest_open_price = 0;
   for(int i=0;i<OrdersTotal();i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if(OrderMagicNumber() == MagicNumber)
            if(OrderType() == OP_SELL)
               if(OrderOpenPrice() > highest_open_price)
                  highest_open_price = OrderOpenPrice();
   }
   return highest_open_price;
}
//+------------------------------------------------------------------+
//|  Lowest Buy Positions Price                                      |
//+------------------------------------------------------------------+
double LowestBuyPrice()
{
   double lowest_open_price = 0;
   for(int i=0;i<OrdersTotal();i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if(OrderMagicNumber() == MagicNumber)
            if(OrderType() == OP_BUY)
            {
               if(lowest_open_price == 0)
               {
                  lowest_open_price = OrderOpenPrice();
               }
               else if(OrderOpenPrice() < lowest_open_price)
                  lowest_open_price = OrderOpenPrice();
            }
   }
   return lowest_open_price;
}
//+------------------------------------------------------------------+
//|  Calculate BreakEven Of buy orders                                     
//+------------------------------------------------------------------+
double BreakEvenOfBuyOrders()
{
   double price = 0,
          lot = 0,
          pricelots = 0,
          TotalLots = 0,
          Totalpricelots = 0,
          BreakEvenPrice = 0;
   for(int i=0;i<OrdersTotal();i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if(OrderMagicNumber() == MagicNumber)
            if(OrderType() == OP_BUY)
            {
               price = OrderOpenPrice();
               lot = OrderLots();
               pricelots = price * lot ;
               TotalLots += lot;
               Totalpricelots += pricelots;
               BreakEvenPrice = Totalpricelots / TotalLots;
            }
   }
   return BreakEvenPrice;
}
//+------------------------------------------------------------------+
//|  Calculate BreakEven Of Sell orders                                     
//+------------------------------------------------------------------+
double BreakEvenOfSellOrders()
{
   double price = 0,
          lot = 0,
          pricelots = 0,
          TotalLots = 0,
          Totalpricelots = 0,
          BreakEvenPrice = 0;
   for(int i=0;i<OrdersTotal();i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if(OrderMagicNumber() == MagicNumber)
            if(OrderType() == OP_SELL)
            {
               price = OrderOpenPrice();
               lot = OrderLots();
               pricelots = price * lot ;
               TotalLots += lot;
               Totalpricelots += pricelots;
               BreakEvenPrice = Totalpricelots / TotalLots;
            }
   }
   return BreakEvenPrice;
}