//+------------------------------------------------------------------+
//|                                                     lesson15.mq4 |
//|                           Copyright 2023,MQL4club Software Corp. |
//|                                       https://www.t.me/mql4club/ |
//+------------------------------------------------------------------+
#property copyright "Copyright 2023,MQL4club Software Corp."
#property link      "https://www.t.me/mql4club/"
#property version   "1.00"
#property strict

#import "shell32.dll"
int ShellExecuteW(int hWnd, string Verb, string File, string Parameter, string Path, int ShowCommand);

#import "kernel32.dll"
int GlobalAlloc(int Flags, int Size);
int GlobalLock(int hMem);
int GlobalUnlock(int hMem);
int GlobalFree(int hMem);
int lstrcpyW(int ptrhMem, string Text);
bool CopyFileW (string existingFile, string newFile, bool overwrite);

#import "user32.dll"
int OpenClipboard(int hOwnerWindow);
int EmptyClipboard();
int CloseClipboard();
int SetClipboardData(int Format, int hMem);
#import

#define GMEM_MOVEABLE   2
#define CF_UNICODETEXT  13
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   ButtonCreate(0,"OpenLinkButton",0,10,20,200,30,0,"google");
   ButtonCreate(0,"CopyButton",0,10,60,200,30,0,"Copy Symbol");
   ButtonCreate(0,"CopyFile",0,10,100,200,30,0,"Copy File");
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   ObjectDelete("OpenLinkButton");
   ObjectDelete("CopyButton");
   ObjectDelete("CopyFile");
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   
  }
//+------------------------------------------------------------------+
//|                    ChartEvent function                           |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{

   if(id==CHARTEVENT_OBJECT_CLICK  &&  sparam=="OpenLinkButton")
   {
      ShellExecuteW(0, "open", "https://www.google.com", NULL, NULL, 1);
      ObjectSetInteger(0,"OpenLinkButton",OBJPROP_STATE,false);
   }

   if(id==CHARTEVENT_OBJECT_CLICK  &&  sparam=="CopyButton")
   {
      bool res = CopyTextToClipboard(_Symbol);      
      ObjectSetInteger(0,"CopyButton",OBJPROP_STATE,false);
   }
   
   if(id==CHARTEVENT_OBJECT_CLICK && sparam=="CopyFile")
   {
      WriteData();
      ObjectSetInteger(0,"CopyFile",OBJPROP_STATE,false);
   }
}
//+------------------------------------------------------------------+
//|               Copy Text To Clipboard                             |
//+------------------------------------------------------------------+
// Copies the specified text to the clipboard, returning true if successful
bool CopyTextToClipboard(string Text)
{
   bool bReturnvalue = false;

// Try grabbing ownership of the clipboard
   if (OpenClipboard(0) != 0)
   {
      // Try emptying the clipboard
      if (EmptyClipboard() != 0)
      {
         // Try allocating a block of global memory to hold the text
         int lnString = StringLen(Text);
         int hMem = GlobalAlloc(GMEM_MOVEABLE, (lnString * 2) + 2);
         if (hMem != 0)
         {
            // Try locking the memory, so that we can copy into it
            int ptrMem = GlobalLock(hMem);
            if (ptrMem != 0)
            {
               // Copy the string into the global memory
               lstrcpyW(ptrMem, Text);
               // Release ownership of the global memory (but don't discard it)
               GlobalUnlock(hMem);

               // Try setting the clipboard contents using the global memory
               if (SetClipboardData(CF_UNICODETEXT, hMem) != 0)
               {
                  // Okay
                  bReturnvalue = true;
               }
               else
               {
                  // Failed to set the clipboard using the global memory
                  GlobalFree(hMem);
               }
            }
            else
            {
               Print("Memory allocated but not locked.");
               GlobalFree(hMem);
            }
         }
         else
         {
            Print("Failed to allocate memory to hold string.");
         }
      }
      else
      {
         Print("Failed to empty clipboard.");
      }
      // Always release the clipboard, even if the copy failed
      CloseClipboard();
   }
   else
   {
      Print("Failed to open clipboard.");
   }

   return (bReturnvalue);
}
//+------------------------------------------------------------------+
//| Create the button                                                |
//+------------------------------------------------------------------+
bool ButtonCreate(const long              chart_ID=0,               // chart's ID
                  const string            name="Button",            // button name
                  const int               sub_window=0,             // subwindow index
                  const int               x=0,                      // X coordinate
                  const int               y=0,                      // Y coordinate
                  const int               width=50,                 // button width
                  const int               height=18,                // button height
                  const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, // chart corner for anchoring
                  const string            text="Button",            // text
                  const string            font="Arial",             // font
                  const int               font_size=10,             // font size
                  const color             clr=clrBlack,             // text color
                  const color             back_clr=clrWhite,  // background color
                  const color             border_clr=clrNONE,       // border color
                  const bool              state=false,              // pressed/released
                  const bool              back=false,               // in the background
                  const bool              selection=false,          // highlight to move
                  const bool              hidden=true,              // hidden in the object list
                  const long              z_order=0)                // priority for mouse click
{
//--- reset the error value
   ResetLastError();
//--- create the button
   if(!ObjectCreate(chart_ID,name,OBJ_BUTTON,sub_window,0,0))
   {
      Print(__FUNCTION__,
            ": failed to create the button! Error code = ",GetLastError());
      return(false);
   }
//--- set button coordinates
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//--- set button size
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
//--- set the chart's corner, relative to which point coordinates are defined
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//--- set the text
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//--- set text font
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
//--- set font size
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//--- set text color
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//--- set background color
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
//--- set border color
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);
//--- display in the foreground (false) or background (true)
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//--- set button state
   ObjectSetInteger(chart_ID,name,OBJPROP_STATE,state);
//--- enable (true) or disable (false) the mode of moving the button by mouse
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//--- hide (true) or display (false) graphical object name in the object list
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//--- set the priority for receiving the event of a mouse click in the chart
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//--- successful execution
   return(true);
} 
//+------------------------------------------------------------------+
//|WriteData                                          
//+------------------------------------------------------------------+
void WriteData()
{
   string file_name = "data.csv";
   int file_handle = FileOpen(file_name,FILE_READ|FILE_WRITE|FILE_CSV|FILE_ANSI,',');
   
   if(file_handle != INVALID_HANDLE)
   {
      FileSeek(file_handle,0,SEEK_SET);
      
      FileWrite(file_handle,High[1],Low[1],Open[1],Close[1]);

//      for(int i=0;i<OrdersTotal();i++)
//      {
//         if(OrderSelect(i,SELECT_BY_POS))
//            FileWrite(file_handle,OrderTicket(),OrderType(),OrderLots(),OrderOpenPrice(),OrderStopLoss(),OrderTakeProfit());
//         
//      }
      FileWrite(file_handle,"End_Write");
      FileClose(file_handle);
   }
//   string from=TerminalPath()+"\\MQL4\\Files";
//   string to="D:\\Forex Terminals";
//   string parameters = "/c copy /Y " + from + " " + to;
//   int copyini =ShellExecuteW(0, "open", "Master_EA"+".ini", parameters, "", 0);
//   Sleep(1200);
//    
//   if(copyini<32)
//   {
//      Print("Fail to copy ini file, error: "+DoubleToStr(copyini,0));return;
//   }

   CopyFileW(TerminalInfoString(TERMINAL_DATA_PATH)+"\\MQL4\\Files\\"+file_name, "d:\\New folder\\"+file_name, false);
   
   Comment(TerminalInfoString(TERMINAL_DATA_PATH));
}