//+------------------------------------------------------------------+
//|                                                   lesson4_EA.mq4 |
//|                          Copyright 2021, MQL4club Software Corp. |
//|                                            https://t.me/MQL4club |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, MQL4club Software Corp."
#property link      "https://t.me/MQL4club"
#property version   "1.00"
#property strict
#property description " this is comment"
#include <stdlib.mqh>


//--- fast ma settings
input string Fast_MA_settings = "---------------- Fast_MA_settings  ------------------";
input int Fast_MA_Period = 7;
input ENUM_MA_METHOD Fast_MA_Method = MODE_SMA;
input ENUM_APPLIED_PRICE Fast_MA_Applied = PRICE_CLOSE;
//--- slow ma settings
input string Slow_MA_settings = "---------------- Slow_MA_settings  ------------------";
input int Slow_MA_Period = 21;
input ENUM_MA_METHOD Slow_MA_Method = MODE_SMA;
input ENUM_APPLIED_PRICE Slow_MA_Applied = PRICE_CLOSE;

//--- input parameters
input string Trade_settings = "---------------- Trade_settings  ------------------";
input double   LotSize=0.01;
input int      StopLoss=20; 
input int      TakeProfit=50;
input int      Slipage = 30;  // slipage (in points)
input ENUM_TIMEFRAMES timeframe = PERIOD_H1;
input string  password = "";  // Please Enter PassWord
input int MagicSeed = 100000;

input string BreakEvenSettings = "------------- BreakEvenSettings -------------";
input bool UseBE = False;
input int WhenToBE = 30; // When To Move To Break Even (in Pips)
input int PipsLock = 2;  // Pips to Lock in (in Pips)

input string TrailSettings = "------------- TrailSettings -------------";
input bool UseTrailingStop = False;
input int WhenToTrail = 50;
input int TrailAmount = 20;

input string CandleTrailSettings = "------------- CandleTrailSettings -------------";
input bool UseCandleTrailingStop = False;
input int CandleBack = 10;
input int PadAmount = 4;

double pips = 0;
int MagicNumber = 0;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   MagicNumber = MagicNumberGenerator();
   Print(MagicNumber);
   
   if(_Digits == 5 || _Digits == 3)
      pips = _Point * 10;
   else 
      pips = _Point;
   
   #include <Checks.mqh>
   
   Comment("The EA Successfully Loaded");
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   if(UseBE) MoveToBreakEven();
   if(UseTrailingStop) TrailingStop();
   
   CheckForSignal();

  }
//+------------------------------------------------------------------+
//|  CheckForSignal                                                  |
//+------------------------------------------------------------------+
void CheckForSignal()
{
   static datetime candleTime = 0;
   if(candleTime != iTime(_Symbol,timeframe,0))
   {
      double FastMa_1 = iMA(_Symbol,timeframe,Fast_MA_Period,0,Fast_MA_Method,Fast_MA_Applied,1);
      double FastMa_2 = iMA(_Symbol,timeframe,Fast_MA_Period,0,Fast_MA_Method,Fast_MA_Applied,2);
      
      double SlowMa_1 = iMA(_Symbol,timeframe,Slow_MA_Period,0,Slow_MA_Method,Slow_MA_Applied,1);
      double SlowMa_2 = iMA(_Symbol,timeframe,Slow_MA_Period,0,Slow_MA_Method,Slow_MA_Applied,2);
      
      if(FastMa_1 > SlowMa_1 && FastMa_2 < SlowMa_2)
         EnterTrade(OP_BUY);
      else if(FastMa_1 < SlowMa_1 && FastMa_2 > SlowMa_2)
         EnterTrade(OP_SELL);
         
      //--- candle time reset
      candleTime = iTime(_Symbol,timeframe,0);
   }
     
}
//+------------------------------------------------------------------+
//|  EnterTrade                                                      |
//+------------------------------------------------------------------+
void EnterTrade(int order_type)
{
   int err;
   double sl=0 , tp=0 , price = 0;
   color order_color = 0;
   
   if(order_type == OP_BUY)
   {
      price = Ask;
      order_color = clrBlue;
   }
   else if(order_type == OP_SELL)
   {
      price = Bid;
      order_color = clrRed;
   }
   
   
   
   
   int ticket = OrderSend(_Symbol,order_type,LotSize,price,Slipage,0,0,"Ma_Expert",MagicNumber,0,order_color);
   
   if(ticket > -1)
   {
      if(OrderSelect(ticket,SELECT_BY_TICKET))
      {
         if(order_type == OP_BUY)
         {
            sl = OrderOpenPrice() - StopLoss * pips;
            tp = OrderOpenPrice() + TakeProfit * pips;
         }
         else if(order_type == OP_SELL)
         {
            sl = OrderOpenPrice() + StopLoss * pips;
            tp = OrderOpenPrice() - TakeProfit * pips;
         
         }
   
         if(!OrderModify(ticket,OrderOpenPrice(),sl,tp,0,clrNONE))
         {
            err = GetLastError();
            Print("could not Modify position due to : ",err,"  ",ErrorDescription(err));

         }
               
      }
      else
      {
          err = GetLastError();
          Print("could not select position due to : ",err,"  ",ErrorDescription(err));
      }
   }
   else
   {
      err = GetLastError();
      Print("could not open position due to : ",err,"  ",ErrorDescription(err));
   }
   
}
//+------------------------------------------------------------------+
//|    Magic Number Generator                                        |
//+------------------------------------------------------------------+
int MagicNumberGenerator()
{
   string mySymbol = StringSubstr(_Symbol,0,6);    
   int GeneratedNumber = 0;
   int pairNumber = 0;
   
   if(mySymbol == "EURUSD") pairNumber = 1;
   else if (mySymbol == "AUDCHF")   pairNumber=2;
   else if (mySymbol == "AUDJPY")   pairNumber=3;
   else if (mySymbol == "AUDNZD")   pairNumber=4;
   else if (mySymbol == "AUDUSD")   pairNumber=5;
   else if (mySymbol == "CADCHF")   pairNumber=6;
   else if (mySymbol == "CADJPY")   pairNumber=7;
   else if (mySymbol == "CHFJPY")   pairNumber=8;
   else if (mySymbol == "EURAUD")   pairNumber=9;
   else if (mySymbol == "EURCAD")   pairNumber=10;
   else if (mySymbol == "EURCHF")   pairNumber=11;
   else if (mySymbol == "EURGBP")   pairNumber=12;
   else if (mySymbol == "EURJPY")   pairNumber=13;
   else if (mySymbol == "EURNZD")   pairNumber=14;
   else if (mySymbol == "AUDCAD")   pairNumber=15;
   else if (mySymbol == "GBPAUD")   pairNumber=16;
   else if (mySymbol == "GBPCAD")   pairNumber=17;
   else if (mySymbol == "GBPCHF")   pairNumber=18;
   else if (mySymbol == "GBPJPY")   pairNumber=19;
   else if (mySymbol == "GBPNZD")   pairNumber=20;
   else if (mySymbol == "GBPUSD")   pairNumber=21;
   else if (mySymbol == "NZDCAD")   pairNumber=22;
   else if (mySymbol == "NZDJPY")   pairNumber=23;
   else if (mySymbol == "NZDCHF")   pairNumber=24;
   else if (mySymbol == "NZDUSD")   pairNumber=25;
   else if (mySymbol == "USDCAD")   pairNumber=26;
   else if (mySymbol == "USDCHF")   pairNumber=27;
   else if (mySymbol == "USDJPY")   pairNumber=28;
   
   GeneratedNumber = MagicSeed + (pairNumber * 1000) + _Period;
   
   return GeneratedNumber;
}
//+------------------------------------------------------------------+
//|   MoveToBreakEven                                                |
//+------------------------------------------------------------------+
void MoveToBreakEven()
{
   for(int i=0;i<OrdersTotal();i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if(OrderMagicNumber() == MagicNumber)
         {
            if(OrderType() == OP_BUY)
            {
               if(Bid - OrderOpenPrice() > WhenToBE * pips)
                  if(OrderStopLoss() < OrderOpenPrice())
                  {
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice() + PipsLock*pips,OrderTakeProfit(),0,clrNONE))
                     {
                        int err = GetLastError();
                        Print("could not Modify position due to : ",err,"  ",ErrorDescription(err));
                     }
                  }
            }
            else if(OrderType() == OP_SELL)
            {
               if(OrderOpenPrice() - Ask > WhenToBE * pips)
                  if(OrderStopLoss() > OrderOpenPrice())
                  {
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice() - PipsLock*pips,OrderTakeProfit(),0,clrNONE))
                     {
                        int err = GetLastError();
                        Print("could not Modify position due to : ",err,"  ",ErrorDescription(err));
                     }
                  }
            }
         }
      }
      else
      {
          int err = GetLastError();
          Print(__FUNCTION__,"could not select position due to : ",err,"  ",ErrorDescription(err));
      }
   }
}
//+------------------------------------------------------------------+
//|  TrailingStop                                                    |
//+------------------------------------------------------------------+
void TrailingStop()
{
   for(int i=0;i<OrdersTotal();i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if(OrderMagicNumber() == MagicNumber)
         {
            if(OrderType() == OP_BUY)
            {
               if(Bid - OrderOpenPrice() > WhenToTrail * pips)
                  if(OrderStopLoss() < Bid - TrailAmount*pips)
                  {
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),Bid - TrailAmount*pips,OrderTakeProfit(),0,clrNONE))
                     {
                        int err = GetLastError();
                        Print("could not Modify position due to : ",err,"  ",ErrorDescription(err));
                     }
                  }
            }
            else if(OrderType() == OP_SELL)
            {
               if(OrderOpenPrice() - Ask > WhenToTrail * pips)
                  if(OrderStopLoss() > Ask + TrailAmount*pips)
                  {
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),Ask + TrailAmount*pips,OrderTakeProfit(),0,clrNONE))
                     {
                        int err = GetLastError();
                        Print("could not Modify position due to : ",err,"  ",ErrorDescription(err));
                     }
                  }
            }
         }
      }
      else
      {
          int err = GetLastError();
          Print(__FUNCTION__,"could not select position due to : ",err,"  ",ErrorDescription(err));
      }
   }
}
