//+------------------------------------------------------------------+
//|                                                   lesson6_EA.mq4 |
//|                          Copyright 2021, MQL4club Software Corp. |
//|                                            https://t.me/MQL4club |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, MQL4club Software Corp."
#property link      "https://t.me/MQL4club"
#property version   "1.00"
#property strict
#property description " this is comment"
#include <stdlib.mqh>

enum ENUM_TRILING_TYPE{Regular , CandleTrail};

//--- fast ma settings
input string Fast_MA_settings = "---------------- Fast_MA_settings  ------------------";
input int Fast_MA_Period = 7;
input ENUM_MA_METHOD Fast_MA_Method = MODE_SMA;
input ENUM_APPLIED_PRICE Fast_MA_Applied = PRICE_CLOSE;
//--- slow ma settings
input string Slow_MA_settings = "---------------- Slow_MA_settings  ------------------";
input int Slow_MA_Period = 21;
input ENUM_MA_METHOD Slow_MA_Method = MODE_SMA;
input ENUM_APPLIED_PRICE Slow_MA_Applied = PRICE_CLOSE;

//--- input parameters
input string Trade_settings = "---------------- Trade_settings  ------------------";
input double   LotSize=0.01;
input int      StopLoss=20; 
input int      TakeProfit=50;
input int      Slipage = 30;  // slipage (in points)
input ENUM_TIMEFRAMES timeframe = PERIOD_H1;
input string  password = "";  // Please Enter PassWord
input int MagicSeed = 100000;
input int MaxOpenPosition = 3;
input bool Hedging = false;
input bool Close_Opposite_signal = true;

input string Martingale_setting = "------------- Martingale Setting ------------";
input bool Martingale = false;
input double Martingale_Mul = 2.0;

input string BreakEvenSettings = "------------- BreakEvenSettings -------------";
input bool UseBE = False;
input int WhenToBE = 30; // When To Move To Break Even (in Pips)
input int PipsLock = 2;  // Pips to Lock in (in Pips)

input string TrailSettings = "------------- TrailSettings -------------";
input bool UseTrailingStop = False;
input ENUM_TRILING_TYPE TrailingType = Regular;

input string RegularTrailSettings = "------------- TrailSettings -------------";
input int WhenToTrail = 50;
input int TrailAmount = 20;

input string CandleTrailSettings = "------------- CandleTrailSettings -------------";
input int CandleBack = 10;
input int PadAmount = 4;

double pips = 0;
int MagicNumber = 0;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   MagicNumber = MagicNumberGenerator();
   Print(MagicNumber);
   
   if(_Digits == 5 || _Digits == 3)
      pips = _Point * 10;
   else 
      pips = _Point;
   
   #include <Checks.mqh>
   
   Comment("The EA Successfully Loaded");
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   if(UseBE) 
      MoveToBreakEven();
   
   if(UseTrailingStop)
      AdjustTrail(); 
      
   
   CheckForSignal();

  }
//+------------------------------------------------------------------+
//|  CheckForSignal                                                  |
//+------------------------------------------------------------------+
void CheckForSignal()
{
   static datetime candleTime = 0;
   if(candleTime != iTime(_Symbol,timeframe,0))
   {
      double FastMa_1 = iMA(_Symbol,timeframe,Fast_MA_Period,0,Fast_MA_Method,Fast_MA_Applied,1);
      double FastMa_2 = iMA(_Symbol,timeframe,Fast_MA_Period,0,Fast_MA_Method,Fast_MA_Applied,2);
      
      double SlowMa_1 = iMA(_Symbol,timeframe,Slow_MA_Period,0,Slow_MA_Method,Slow_MA_Applied,1);
      double SlowMa_2 = iMA(_Symbol,timeframe,Slow_MA_Period,0,Slow_MA_Method,Slow_MA_Applied,2);
      
      if(FastMa_1 > SlowMa_1 && FastMa_2 < SlowMa_2)
      {
         if(Close_Opposite_signal && TotalOpenOrders(OP_SELL)>0 )
            CloseTrade(OP_SELL);
         
         if(TotalOpenOrders() < MaxOpenPosition)
            if((!Hedging && TotalOpenOrders(OP_SELL)==0) || Hedging)
               EnterTrade(OP_BUY);
      }
      else if(FastMa_1 < SlowMa_1 && FastMa_2 > SlowMa_2)
      {
         if(Close_Opposite_signal && TotalOpenOrders(OP_BUY)>0 )
            CloseTrade(OP_BUY);
            
         if(TotalOpenOrders() < MaxOpenPosition)
            if((!Hedging && TotalOpenOrders(OP_BUY)==0) || Hedging)
               EnterTrade(OP_SELL);
      }   
      //--- candle time reset
      candleTime = iTime(_Symbol,timeframe,0);
   }
     
}
//+------------------------------------------------------------------+
//|  EnterTrade                                                      |
//+------------------------------------------------------------------+
void EnterTrade(int order_type)
{
   int err;
   double sl=0 , tp=0 , price = 0;
   color order_color = 0;
   
   if(order_type == OP_BUY)
   {
      price = Ask;
      order_color = clrBlue;
   }
   else if(order_type == OP_SELL)
   {
      price = Bid;
      order_color = clrRed;
   }
   
   double Lot = LotSize;
   
   if(Martingale)
   {
      int ticket = Last_Ticket();
      
      if(OrderSelect(ticket,SELECT_BY_TICKET))
      {
         if(OrderProfit() < 0)
            Lot = Martingale_Mul * OrderLots();
      }
      
   }
   Lot = NormalizeDouble(Lot,2);
   
   int ticket = OrderSend(_Symbol,order_type,Lot,price,Slipage,0,0,"Ma_Expert",MagicNumber,0,order_color);
   
   if(ticket > -1)
   {
      if(OrderSelect(ticket,SELECT_BY_TICKET))
      {
         if(order_type == OP_BUY)
         {
            sl = OrderOpenPrice() - StopLoss * pips;
            tp = OrderOpenPrice() + TakeProfit * pips;
         }
         else if(order_type == OP_SELL)
         {
            sl = OrderOpenPrice() + StopLoss * pips;
            tp = OrderOpenPrice() - TakeProfit * pips;
         
         }
         
         if(StopLoss == 0)
            sl = 0;
         if(TakeProfit == 0)  
            tp = 0;
   
         if(!OrderModify(ticket,OrderOpenPrice(),sl,tp,0,clrNONE))
         {
            err = GetLastError();
            Print("could not Modify position due to : ",err,"  ",ErrorDescription(err));

         }
               
      }
      else
      {
          err = GetLastError();
          Print("could not select position due to : ",err,"  ",ErrorDescription(err));
      }
   }
   else
   {
      err = GetLastError();
      Print("could not open position due to : ",err,"  ",ErrorDescription(err));
   }
   
}
//+------------------------------------------------------------------+
//|    Magic Number Generator                                        |
//+------------------------------------------------------------------+
int MagicNumberGenerator()
{
   string mySymbol = StringSubstr(_Symbol,0,6);    
   int GeneratedNumber = 0;
   int pairNumber = 0;
   
   if(mySymbol == "EURUSD") pairNumber = 1;
   else if (mySymbol == "AUDCHF")   pairNumber=2;
   else if (mySymbol == "AUDJPY")   pairNumber=3;
   else if (mySymbol == "AUDNZD")   pairNumber=4;
   else if (mySymbol == "AUDUSD")   pairNumber=5;
   else if (mySymbol == "CADCHF")   pairNumber=6;
   else if (mySymbol == "CADJPY")   pairNumber=7;
   else if (mySymbol == "CHFJPY")   pairNumber=8;
   else if (mySymbol == "EURAUD")   pairNumber=9;
   else if (mySymbol == "EURCAD")   pairNumber=10;
   else if (mySymbol == "EURCHF")   pairNumber=11;
   else if (mySymbol == "EURGBP")   pairNumber=12;
   else if (mySymbol == "EURJPY")   pairNumber=13;
   else if (mySymbol == "EURNZD")   pairNumber=14;
   else if (mySymbol == "AUDCAD")   pairNumber=15;
   else if (mySymbol == "GBPAUD")   pairNumber=16;
   else if (mySymbol == "GBPCAD")   pairNumber=17;
   else if (mySymbol == "GBPCHF")   pairNumber=18;
   else if (mySymbol == "GBPJPY")   pairNumber=19;
   else if (mySymbol == "GBPNZD")   pairNumber=20;
   else if (mySymbol == "GBPUSD")   pairNumber=21;
   else if (mySymbol == "NZDCAD")   pairNumber=22;
   else if (mySymbol == "NZDJPY")   pairNumber=23;
   else if (mySymbol == "NZDCHF")   pairNumber=24;
   else if (mySymbol == "NZDUSD")   pairNumber=25;
   else if (mySymbol == "USDCAD")   pairNumber=26;
   else if (mySymbol == "USDCHF")   pairNumber=27;
   else if (mySymbol == "USDJPY")   pairNumber=28;
   
   GeneratedNumber = MagicSeed + (pairNumber * 1000) + _Period;
   
   return GeneratedNumber;
}
//+------------------------------------------------------------------+
//|   MoveToBreakEven                                                |
//+------------------------------------------------------------------+
void MoveToBreakEven()
{
   for(int i=0;i<OrdersTotal();i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if(OrderMagicNumber() == MagicNumber)
         {
            if(OrderType() == OP_BUY)
            {
               if(Bid - OrderOpenPrice() > WhenToBE * pips)
                  if(OrderStopLoss() < OrderOpenPrice())
                  {
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice() + PipsLock*pips,OrderTakeProfit(),0,clrNONE))
                     {
                        int err = GetLastError();
                        Print("could not Modify position due to : ",err,"  ",ErrorDescription(err));
                     }
                  }
            }
            else if(OrderType() == OP_SELL)
            {
               if(OrderOpenPrice() - Ask > WhenToBE * pips)
                  if(OrderStopLoss() > OrderOpenPrice() || OrderStopLoss() == 0)
                  {
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice() - PipsLock*pips,OrderTakeProfit(),0,clrNONE))
                     {
                        int err = GetLastError();
                        Print("could not Modify position due to : ",err,"  ",ErrorDescription(err));
                     }
                  }
            }
         }
      }
      else
      {
          int err = GetLastError();
          Print(__FUNCTION__,"could not select position due to : ",err,"  ",ErrorDescription(err));
      }
   }
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void TrailingStop()
{
   for(int i=0;i<OrdersTotal();i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if(OrderMagicNumber() == MagicNumber)
         {
            if(OrderType() == OP_BUY)
            {
               if(Bid - OrderOpenPrice() > WhenToTrail * pips)
                  if(OrderStopLoss() < Bid - TrailAmount*pips)
                  {
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),Bid - TrailAmount*pips,OrderTakeProfit(),0,clrNONE))
                     {
                        int err = GetLastError();
                        Print("could not Modify position due to : ",err,"  ",ErrorDescription(err));
                     }
                  }
            }
            else if(OrderType() == OP_SELL)
            {
               if(OrderOpenPrice() - Ask > WhenToTrail * pips)
                  if(OrderStopLoss() > Ask + TrailAmount*pips  || OrderStopLoss() == 0)
                  {
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),Ask + TrailAmount*pips,OrderTakeProfit(),0,clrNONE))
                     {
                        int err = GetLastError();
                        Print("could not Modify position due to : ",err,"  ",ErrorDescription(err));
                     }
                  }
            }
         }
      }
      else
      {
          int err = GetLastError();
          Print(__FUNCTION__,"could not select position due to : ",err,"  ",ErrorDescription(err));
      }
   }
}
//+------------------------------------------------------------------+
//|  AdjustTrail                                                     |
//+------------------------------------------------------------------+
void AdjustTrail()
{
   if(TrailingType == Regular)
      TrailingStop();
   else if(TrailingType == CandleTrail)
      CandleTrail();
}
//+------------------------------------------------------------------+
//|  CandleTril                                                      |
//+------------------------------------------------------------------+
void CandleTrail()
{
   for(int i=0;i<OrdersTotal();i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if(OrderMagicNumber() == MagicNumber)
         {
            if(OrderType() == OP_BUY)
            {
               int LowestCandle = iLowest(_Symbol,timeframe,MODE_LOW,CandleBack,1);
               if(OrderStopLoss() < Low[LowestCandle] - PadAmount*pips)
               {
                  double stop = NormalizeDouble((Low[LowestCandle] - PadAmount*pips),_Digits);
                  if(!OrderModify(OrderTicket(),OrderOpenPrice(),stop,OrderTakeProfit(),0,clrNONE))
                  {
                        int err = GetLastError();
                        Print("could not Modify position due to : ",err,"  ",ErrorDescription(err));
                  }
               }
            }
            else if(OrderType() == OP_SELL)
            {
               int HighestCandle = iHighest(_Symbol,timeframe,MODE_HIGH,CandleBack,1);
               if((OrderStopLoss() > High[HighestCandle] + PadAmount*pips ) || OrderStopLoss() == 0)
               {
                  double stop = NormalizeDouble((High[HighestCandle] + PadAmount*pips),_Digits);
                  if(!OrderModify(OrderTicket(),OrderOpenPrice(),stop,OrderTakeProfit(),0,clrNONE))
                  {
                        int err = GetLastError();
                        Print("could not Modify position due to : ",err,"  ",ErrorDescription(err));
                  }
               }
            }
         }
      }
      else
      {
          int err = GetLastError();
          Print(__FUNCTION__,"could not select position due to : ",err,"  ",ErrorDescription(err));
      }
   }
}
//+------------------------------------------------------------------+
//| TotalOpenOrders                                                  |
//+------------------------------------------------------------------+
int TotalOpenOrders()
{
   int Total = 0;
   for(int i=0;i<OrdersTotal();i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if(OrderMagicNumber() == MagicNumber)
         {
            Total++;
         }
      }
      else
      {
          int err = GetLastError();
          Print(__FUNCTION__,"could not select position due to : ",err,"  ",ErrorDescription(err));
      }
   }
   return Total;
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int TotalOpenOrders(int Type)
{
   int Total = 0;
   for(int i=0;i<OrdersTotal();i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if(OrderMagicNumber() == MagicNumber)
         {
            if(OrderType() == Type)
               Total++;
         }
      }
      else
      {
          int err = GetLastError();
          Print(__FUNCTION__,"could not select position due to : ",err,"  ",ErrorDescription(err));
      }
   }
   return Total;
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CloseTrade(int type)
{
   for(int i=0;i<OrdersTotal();i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if(OrderMagicNumber() == MagicNumber)
         {
            if(OrderType() == type)
            {
               double price = Ask;
               if(type == OP_BUY) price = Bid;
               
               int j = 1;
               while(j<= 6)
               {
                  bool result = OrderClose(OrderTicket(),OrderLots(),price,Slipage,clrYellow);
                  int err;
                  if(result)
                     break;
                     
                  else if(result == false)
                  {
                     err = GetLastError();
                     Print(__FUNCTION__,"could not select position due to : ",err,"  ",ErrorDescription(err));
                  
                     if(err == ERR_INVALID_TICKET)
                     {
                        Print("order Closed");
                        break;
                     }
                     
                     switch(err)
                       {
                        case  135:
                        case  136:
                        case  137:
                        case  138:
                        case  141:
                        Sleep(1000);
                        RefreshRates();
                          break;
                        default:
                          break;
                       }
                  }
                  j++;
                  if(j>6)
                     Print("Could not Close Order Due to :",err,"  ",ErrorDescription(err));
               }
               
               
               
            }
         }
      }  
      else
      {
          int err = GetLastError();
          Print(__FUNCTION__,"could not select position due to : ",err,"  ",ErrorDescription(err));
      }
   }
}


//+------------------------------------------------------------------+
//| Last_Ticket                                                      |
//+------------------------------------------------------------------+
int Last_Ticket()
{
   int ticket = 0;
   for(int i=OrdersHistoryTotal()-1;i>=0;i--)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
      {
         if(OrderMagicNumber() == MagicNumber)
         {
            ticket = OrderTicket();
            break;
         }
      }
   }
   return ticket;
}







