//+------------------------------------------------------------------+
//|                                                   lesson7_EA.mq4 |
//|                          Copyright 2021, MQL4club Software Corp. |
//|                                            https://t.me/MQL4club |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, MQL4club Software Corp."
#property link      "https://t.me/MQL4club"
#property version   "1.00"
#property strict
#property description " this is comment"
#include <stdlib.mqh>


//--- input parameters
input string Trade_settings = "---------------- Trade_settings  ------------------";
input double   LotSize=0.01;
input int      StopLoss=30; 
input double      TakeProfit=60;
input int      Slipage = 30;  // slipage (in points)
input int MagicSeed = 100000;
extern double MartingaleMul = 1.5;
input bool Martingale_Auto = true;

double pips = 0;
int MagicNumber = 0;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   MagicNumber = MagicNumberGenerator();
   Print(MagicNumber);
   
   if(_Digits == 5 || _Digits == 3)
      pips = _Point * 10;
   else 
      pips = _Point;
   
   #include <Checks.mqh>
   
   if(Martingale_Auto)
      if(TakeProfit > 0)
         MartingaleMul = (TakeProfit + StopLoss) / TakeProfit;
   
   Comment("The EA Successfully Loaded");
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
 
   CheckForSignal();

  }
//+------------------------------------------------------------------+
//|  CheckForSignal                                                  |
//+------------------------------------------------------------------+
void CheckForSignal()
{
    
       
   if(TotalOpenOrders() == 0)
   {
      if(OrderSelect(Last_Ticket(),SELECT_BY_TICKET))
         if(OrderProfit() < 0)
         {
            EnterOppositeTrade(OrderType(),OrderLots(),OrderComment());
            return;
         }
   
      int Type = rand() % 2 ;
      EnterTrade(Type);
   }   
   
}
//+------------------------------------------------------------------+
//|  EnterTrade                                                      |
//+------------------------------------------------------------------+
void EnterTrade(int order_type)
{
   int err;
   double sl=0 , tp=0 , price = 0;
   color order_color = 0;
   
   if(order_type == OP_BUY)
   {
      price = Ask;
      order_color = clrBlue;
   }
   else if(order_type == OP_SELL)
   {
      price = Bid;
      order_color = clrRed;
   }
   
   double Lot = LotSize;
   
   Lot = NormalizeDouble(Lot,2);
   string Order_Comment = "1";
   Print(Order_Comment);
   int ticket = OrderSend(_Symbol,order_type,Lot,price,Slipage,0,0,Order_Comment,MagicNumber,0,order_color);
   
   if(ticket > -1)
   {
      if(OrderSelect(ticket,SELECT_BY_TICKET))
      {
         if(order_type == OP_BUY)
         {
            sl = OrderOpenPrice() - StopLoss * pips;
            tp = OrderOpenPrice() + TakeProfit * pips;
         }
         else if(order_type == OP_SELL)
         {
            sl = OrderOpenPrice() + StopLoss * pips;
            tp = OrderOpenPrice() - TakeProfit * pips;
         
         }
         
         if(StopLoss == 0)
            sl = 0;
         if(TakeProfit == 0)  
            tp = 0;
   
         if(!OrderModify(ticket,OrderOpenPrice(),sl,tp,0,clrNONE))
         {
            err = GetLastError();
            Print("could not Modify position due to : ",err,"  ",ErrorDescription(err));

         }
               
      }
      else
      {
          err = GetLastError();
          Print("could not select position due to : ",err,"  ",ErrorDescription(err));
      }
   }
   else
   {
      err = GetLastError();
      Print("could not open position due to : ",err,"  ",ErrorDescription(err));
   }
   
}
//+------------------------------------------------------------------+
//|  EnterOppositeTrade                                                   
//+------------------------------------------------------------------+
void EnterOppositeTrade(int order_type , double lot , string comment)
{
   int err;
   double sl=0 , tp=0 , price = 0;
   color order_color = 0;
   
   if(order_type == OP_BUY)
   {
      order_type = OP_SELL;
      price = Bid;
      order_color = clrRed;
   }
   else if(order_type == OP_SELL)
   {
      order_type = OP_BUY;      
      price = Ask;
      order_color = clrBlue;
   }
   
   double Lot = lot * MartingaleMul;
   
   Lot = NormalizeDouble(Lot,2);
   int PositionNumber = (int)comment +1 ;
   comment = (string)PositionNumber;
   Print(comment);
   int ticket = OrderSend(_Symbol,order_type,Lot,price,Slipage,0,0,comment,MagicNumber,0,order_color);
   
   if(ticket > -1)
   {
      if(OrderSelect(ticket,SELECT_BY_TICKET))
      {
         if(order_type == OP_BUY)
         {
            sl = OrderOpenPrice() - StopLoss * pips;
            tp = OrderOpenPrice() + TakeProfit * pips;
         }
         else if(order_type == OP_SELL)
         {
            sl = OrderOpenPrice() + StopLoss * pips;
            tp = OrderOpenPrice() - TakeProfit * pips;
         
         }
         
         if(StopLoss == 0)
            sl = 0;
         if(TakeProfit == 0)  
            tp = 0;
   
         if(!OrderModify(ticket,OrderOpenPrice(),sl,tp,0,clrNONE))
         {
            err = GetLastError();
            Print("could not Modify position due to : ",err,"  ",ErrorDescription(err));

         }
               
      }
      else
      {
          err = GetLastError();
          Print("could not select position due to : ",err,"  ",ErrorDescription(err));
      }
   }
   else
   {
      err = GetLastError();
      Print("could not open position due to : ",err,"  ",ErrorDescription(err));
   }
   
}

//+------------------------------------------------------------------+
//|    Magic Number Generator                                        |
//+------------------------------------------------------------------+
int MagicNumberGenerator()
{
   string mySymbol = StringSubstr(_Symbol,0,6);    
   int GeneratedNumber = 0;
   int pairNumber = 0;
   
   if(mySymbol == "EURUSD") pairNumber = 1;
   else if (mySymbol == "AUDCHF")   pairNumber=2;
   else if (mySymbol == "AUDJPY")   pairNumber=3;
   else if (mySymbol == "AUDNZD")   pairNumber=4;
   else if (mySymbol == "AUDUSD")   pairNumber=5;
   else if (mySymbol == "CADCHF")   pairNumber=6;
   else if (mySymbol == "CADJPY")   pairNumber=7;
   else if (mySymbol == "CHFJPY")   pairNumber=8;
   else if (mySymbol == "EURAUD")   pairNumber=9;
   else if (mySymbol == "EURCAD")   pairNumber=10;
   else if (mySymbol == "EURCHF")   pairNumber=11;
   else if (mySymbol == "EURGBP")   pairNumber=12;
   else if (mySymbol == "EURJPY")   pairNumber=13;
   else if (mySymbol == "EURNZD")   pairNumber=14;
   else if (mySymbol == "AUDCAD")   pairNumber=15;
   else if (mySymbol == "GBPAUD")   pairNumber=16;
   else if (mySymbol == "GBPCAD")   pairNumber=17;
   else if (mySymbol == "GBPCHF")   pairNumber=18;
   else if (mySymbol == "GBPJPY")   pairNumber=19;
   else if (mySymbol == "GBPNZD")   pairNumber=20;
   else if (mySymbol == "GBPUSD")   pairNumber=21;
   else if (mySymbol == "NZDCAD")   pairNumber=22;
   else if (mySymbol == "NZDJPY")   pairNumber=23;
   else if (mySymbol == "NZDCHF")   pairNumber=24;
   else if (mySymbol == "NZDUSD")   pairNumber=25;
   else if (mySymbol == "USDCAD")   pairNumber=26;
   else if (mySymbol == "USDCHF")   pairNumber=27;
   else if (mySymbol == "USDJPY")   pairNumber=28;
   
   GeneratedNumber = MagicSeed + (pairNumber * 1000) + _Period;
   
   return GeneratedNumber;
}
//+------------------------------------------------------------------+
//| TotalOpenOrders                                                  |
//+------------------------------------------------------------------+
int TotalOpenOrders()
{
   int Total = 0;
   for(int i=0;i<OrdersTotal();i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if(OrderMagicNumber() == MagicNumber)
         {
            Total++;
         }
      }
      else
      {
          int err = GetLastError();
          Print(__FUNCTION__,"could not select position due to : ",err,"  ",ErrorDescription(err));
      }
   }
   return Total;
}


//+------------------------------------------------------------------+
//| Last_Ticket                                                      |
//+------------------------------------------------------------------+
int Last_Ticket()
{
   int ticket = 0;
   for(int i=OrdersHistoryTotal()-1;i>=0;i--)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
      {
         if(OrderMagicNumber() == MagicNumber)
         {
            ticket = OrderTicket();
            break;
         }
      }
   }
   return ticket;
}







